/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package tictactoecodingame;
import java.util.ArrayList;
import java.util.Random;

/**
 *
 * @author Pierre
 */
public class AlgoMCTSBis extends AlgoRecherche{
      Random rnd;
      Joueur joueur2; //humain
      Joueur joueur1; //l'ordinateur
      Joueur currentjoueur; //une variable qui sert à alterner les bots dans la simulation
      Coup meilleur_coup; //le meilleur coup
      Noeud noeud_actuel; //le noeud représentatif de la partie au moment du coup à calculer
      Noeud feuille; //le noeud ou s'arrête l'algorithme de selection
      Plateau _plateau; //le plateau
      Joueur vainqueur_force;//vainqueur force est une variable servant à verifier si un coup dans Selection ou Expansion finit la partie
      Noeud enfant;//l'enfant à partir duquel on simule une partie au hasard après la phase d'expansion
      Joueur vainqueur;//le vainqueur du plteau
      
 public AlgoMCTSBis(Joueur _joueur1, Joueur _joueur2) { //le constructeur
         joueur1 = _joueur1;
         joueur2 = _joueur2;
         rnd = new Random();
 
    }


    @Override
    public Coup meilleurCoup(Plateau plateau, Joueur _joueur1, boolean _ponder){ //notre fonction principale qui renvoie le coup à jouer
        
         
        currentjoueur = _joueur1; //on initialise les variables
        _plateau = plateau;
        _plateau.sauvegardePosition(0);
        
        if (noeud_actuel == null){ //si on commence une partie il faut créer le premier noeud
            noeud_actuel = new Noeud(currentjoueur.getIdJoueur(), null);
            noeud_actuel.coups = _plateau.getListeCoups(currentjoueur);
            Expansion(noeud_actuel, _plateau);
        }
        
        else { //sinon on passe au noeud correspondant au dernier coup joué par l'adversaire
            int i =0;
            while(!(noeud_actuel.coups.get(i).toString().equals(_plateau.getDernierCoup().toString()))){
                i+=1;
             }
           Expansion(noeud_actuel, _plateau);
           noeud_actuel = noeud_actuel.fils.get(i);      
        }
              
        int nb_sim = 600; //Le nombre de simulation à réaliser que l'on peut choisir
        int index =0;
         
        _plateau.restaurePosition(0); 
        
        for(int j=0; j < nb_sim; j++){ //la boucle qui réalise les 4 phases de l'algorithme MCTS
            
            vainqueur = null; //on initialise les variables
            vainqueur_force = null;
            
            feuille = Selection(noeud_actuel, _plateau); //on appelle la selection
            
            if(vainqueur_force == null){ //on vérifie que la partie n'a pas été finie durant la phase de selection
                 enfant = Expansion(feuille, _plateau);
            }
            else{ 
                vainqueur = vainqueur_force;
                enfant = feuille;     
            }
            
            if(vainqueur_force == null){ //on vérifie que la partie n'a pas été finie durant la phase d'expansion
                vainqueur = Simulation(_plateau, enfant); //on appelle la simulation 
            }
            
            else{
                vainqueur = vainqueur_force;
            }
            
           Backpropagation(vainqueur, enfant, noeud_actuel); //la backpropagation des résultats
           
            _plateau.restaurePosition(0);
        }
        
        double max_vic = 0;  
        
        for(int k = 0; k<noeud_actuel.coups.size(); k++){ //on parcours les enfants du noeud actuel et on sélectionne le meilleur pour récuperer le meilleur coup
            
            Noeud test = noeud_actuel.fils.get(k);
            if(test.nbVictoire/test.nbJoue>= max_vic){   
                max_vic = test.nbVictoire/test.nbJoue;
                meilleur_coup = noeud_actuel.coups.get(k);
                index = k;
            }
        } 
        
        noeud_actuel = noeud_actuel.fils.get(index); //on actualise le noeud actuel
        return meilleur_coup; //on renvoie ce coup
    }
    
    
    
    
    
      
    public Noeud Expansion(Noeud noeud_act, Plateau _plateau){
        
        Random aleat = new Random();
        int currentJoueur;
        
        if(noeud_act.joueur==1){
            currentJoueur=2;              // Le current_joueur sera le joeur des noeuds fils, doonc l'autre joueur
        }
        else{
            currentJoueur=1;
        }
        
        for(int i=0;i<noeud_act.coups.size();i++){ //on parcours la liste des coups possibles à partir d'un noeud et on crée ses enfants
            
            Noeud fils= new Noeud(currentJoueur,noeud_act);
            noeud_act.fils.add(fils);                         //On remplit la liste des fils 
            fils.nbJoue = 0;
            fils.nbVictoire =0;
            
            
            if (currentJoueur ==1){
            _plateau.joueCoup(noeud_act.coups.get(i));
            fils.coups = _plateau.getListeCoups(joueur1);
            _plateau.annuleDernierCoup();
             }
            
             else {
            _plateau.joueCoup(noeud_act.coups.get(i));
            fils.coups = _plateau.getListeCoups(joueur2);
            _plateau.annuleDernierCoup();
             }
            
            
        }
        
        Noeud noeud_nouveau;
        
        if(noeud_act.aDesFils()){ //on sélectionne un enfant au hasard qui servira pour la simulation et on vérifie si la partie n'a pas été gagnée entre temps
            
            int b = aleat.nextInt(noeud_act.coups.size());
            noeud_nouveau=noeud_act.fils.get(b);
            _plateau.joueCoup(noeud_act.coups.get(b));
            
           if(_plateau.partieGagnee()){
                
                if(_plateau.vainqueur() == joueur2){
                vainqueur_force = joueur2;}
                else if(_plateau.vainqueur() == joueur1){
                        vainqueur_force = joueur1;
                        }
                else{
                    vainqueur_force = null;
                }                
            }
        }
        else{
            noeud_nouveau = noeud_act;
        }

        return noeud_nouveau;                //On retourne un noeud aléatoire dans la liste des fils de noeud_actuel
    }


public Noeud Selection(Noeud noeud_act, Plateau _plateau){
    
  while(noeud_act.aDesFils()){ //tant qu'on a pas atteind une feuille de l'arbre
       
  double max = 0; //on initialise les variables
  int index = 0;
  Noeud noeud_tempo = noeud_act.fils.get(0);

  for(int i = 0; i<noeud_act.fils.size(); i++){ //on parcourt les enfants d'un noeud pour trouver le plus prometteur
      
       double score;
       Noeud enfant_selec = noeud_act.fils.get(i);
      
       if (enfant_selec.nbJoue ==0){        
           score = 1000;
       }
       
       else{
           score = enfant_selec.nbVictoire/enfant_selec.nbJoue + Math.sqrt(2)*Math.sqrt(Math.log(noeud_act.nbJoue)/enfant_selec.nbJoue);
       }
              
       if (score > max){
           noeud_tempo = enfant_selec;
           index = i;
           max = score;
       }
   }
  
   _plateau.joueCoup(noeud_act.coups.get(index)); //on passe au fils le plus prometteur en vérifiant qu'on a pas fini la partie
   noeud_act = noeud_tempo;
   
    if(_plateau.partieGagnee()){
        if(_plateau.vainqueur() == joueur2){
                vainqueur_force = joueur2;
        }
        else if(_plateau.vainqueur() == joueur1){
                vainqueur_force = joueur1;
        }
        else{
                vainqueur_force = null;
        }                
    }               
}  
return noeud_act;

}


public void Backpropagation(Joueur vainqueur, Noeud noeud, Noeud racine){
    
    int gagnant;
    
    if (vainqueur == joueur1){
        gagnant = 1;
    }
    else{
        gagnant = 2;
    }
    
    while(noeud != racine.pere){ //tant qu'on a pas atteind la racine on continue de propager les résultats 
        
        if (noeud.joueur == gagnant){
            noeud.nbJoue += 1;                 
        }
        else{
            noeud.nbJoue += 1;
            noeud.nbVictoire +=1;
        } 
     noeud = noeud.pere;
    }
}



public Joueur Simulation(Plateau _plateau , Noeud noeud_simulation){
       
        Random alea = new Random();
        if(noeud_simulation.joueur==1){ //on récupère le joueur qui doit commencer à jouer dans la simulation
            currentjoueur=joueur1;
        }
        else{
            currentjoueur=joueur2;
        }
            while(!_plateau.partieTerminee()){ //tant que la partie n'est pas terminée on joue des coups au hasard en alternant les joueurs
                    ArrayList<Coup> coups= _plateau.getListeCoups(currentjoueur);
                    _plateau.joueCoup(coups.get(alea.nextInt(coups.size())));
                    if(currentjoueur==joueur1){
                        currentjoueur=joueur2;
                    }
                    else{
                        currentjoueur=joueur1;
                    }
		}
                return _plateau.vainqueur(); //on renvoie le vainqueur pour la backpropagation
    }


}
